//=======================================================================================
//
//  Purpose:    Implement the assignment operators for the ShiftRegister class.
//
//  Copyright (C) 2011 Mark Stevens
//
//  Permission is hereby granted, free of charge, to any person obtaining a copy
//  of this software and associated documentation files (the "Software") to use
//  the Software in a non-commercial environment subject to the following conditions:
//
//  1.  The above copyright notice and this permission notice shall be included in
//      all copies or substantial portions of the Software.
//  2.  The original author shall be acknowledged in any software and documentation
//      including (but not restricted to) books, articles and online posts.
//
//  Use in a commercial environment is subject to the written consent of the author
//  and/or copyright holder.
//
//  The Software, documentation, instructions for use and associated materials
//  are provided "as is" without warranty of any kind express or implied.  The
//  author and copyright holders shall ihn no way be held liable for any claim
//  or damages arising as a result of the use of the software and/or documentation.
//
//=======================================================================================

namespace Nevyn.co.uk
{
    partial class ShiftRegister
    {
        /// <summary>
        /// Overload the assignment operator.
        /// </summary>
        /// <param name="usi">Unsigned short integer to assign to the register.</param>
        /// <returns>New ShiftRegister holding the unsigned short value.</returns>
        public static implicit operator ShiftRegister(ushort usi)
        {
            ShiftRegister result = new ShiftRegister(16);   // ushorts are 16 bits.

            ushort mask = 1;
            for (int index = 0; index < 16; index++)
            {
                result._bits[index] = (usi & mask) > 0;
                mask <<= 1;
            }
            return (result);
        }
    }
}
